﻿Imports System.IO
Imports System.Threading
Imports System.Drawing

'***************************************************************************
'Gioco del 2048 realizzato da *** Tebaldo Ulleri *** in Data 12-Aprile-2018
'***************************************************************************
Public Class Form1_2048_Game

    '***********************************************************************
    'Variabili globali
    Public Mat4x4Pict_2040() As PictureBox = {}
    Public Matrice4x4(4, 4) As Integer
    Public Matrice_Back1(4, 4) As Integer
    Public Potenze_del_2() As Int32 = {2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192}
    Public Stato_eventi As Int32
    Public Punteggio As Int32
    Public mosse As Int32
    Public Record As Int32
    Public Giocatore As String
    Public Max_Potenza_Raggiunta As Int32
    Public Ultima_Potenza As Int32
    Public Nuovo_Record As Boolean
    Public Scambio_ok As Boolean
    Public Scambio_ok_Back As Boolean
    Public Obiettivi_Punteggio() As Int32 = {2048, 4096, 8192}
    ' Suono1.
    Dim Suono1 = New System.Media.SoundPlayer("C:\Windows\Media\chord.wav")
    ' Suono2.
    Dim Suono2 = New System.Media.SoundPlayer("C:\Windows\Media\tada.wav")
    ' Suono3.
    Dim Suono3 = New System.Media.SoundPlayer("C:\Windows\Media\notify.wav")
    ' Suono4.
    ' Inserire in Resources una musica di tipo WAV e richiamarla quà sotto in My.Resources........
    Dim Suono4 = New System.Media.SoundPlayer(My.Resources.win)
    ' Suono5.
    ' Inserire in Resources una musica di tipo WAV e richiamarla quà sotto in My.Resources........
    Dim Suono5 = New System.Media.SoundPlayer(My.Resources.VGOMyMove)

    '***********************************************************************

    Sub New()
        ' Chiamata richiesta dalla finestra di progettazione.
        InitializeComponent()
        ' Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent().

    End Sub


    Private Sub Form1_2048_Game_Load(sender As Object, e As EventArgs) Handles Me.Load

        Nuovo_Record = False
        Scambio_ok = True
        Scambio_ok_Back = True
        Call Inizializza_Matrice2048(Matrice4x4)
        Stato_eventi = Stato.Azzerato
        Application.DoEvents()
        Call CreaSchema4X4Classic2048()
        Application.DoEvents()
        Call Random_Matrice4x4_2048(Matrice4x4)
        Application.DoEvents()
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        Application.DoEvents()
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
        Application.DoEvents()
        Me.Text &= " v.2.0.1 by Dev. T.U."
        Me.TextBox_Nome.BackColor = Color.Yellow

    End Sub

    Enum Stato
        Azzerato 'idex 0
        Avviato
        Completato
        Errato 'index 3
    End Enum
    'Disegna lo shema 4 x 4 del gioco
    Public Sub CreaSchema4X4Classic2048()
        Panel1.Controls.Clear()
        ReDim Mat4x4Pict_2040(16)
        Dim xP, yP, nCel, size_c As Integer
        xP = 20
        yP = 20
        nCel = 0
        size_c = 84

        For i As Int32 = 1 To 4 Step +1
            xP = 20
            For j As Int32 = 1 To 4 Step +1
                nCel += 1
                Mat4x4Pict_2040(nCel) = New PictureBox
                Mat4x4Pict_2040(nCel).AutoSize = False
                Mat4x4Pict_2040(nCel).Font = New System.Drawing.Font("Arial", 12, FontStyle.Bold)
                Mat4x4Pict_2040(nCel).Size = New System.Drawing.Size(size_c, size_c)
                Mat4x4Pict_2040(nCel).Location = New System.Drawing.Point(xP, yP)
                Mat4x4Pict_2040(nCel).BackColor = Color.Bisque
                Mat4x4Pict_2040(nCel).ForeColor = Color.Maroon
                Mat4x4Pict_2040(nCel).Name = "Cella_" & i.ToString & "-" & j.ToString
                Mat4x4Pict_2040(nCel).Text = j.ToString
                Mat4x4Pict_2040(nCel).Tag = (i).ToString & "-" & (j).ToString
                Mat4x4Pict_2040(nCel).BackgroundImageLayout = ImageLayout.Center
                Panel1.Controls.Add(Mat4x4Pict_2040(nCel))
                If nCel Mod 3 = 0 Then
                    xP = xP + (size_c + 2)
                Else
                    xP = xP + (size_c + 2)
                End If
            Next j
            If i Mod 3 = 0 Then
                yP = yP + (size_c + 2)
            Else
                yP = yP + (size_c + 2)
            End If
        Next i


    End Sub

    Private Sub But_UP_Click(sender As Object, e As EventArgs) Handles But_UP.Click
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
        Scambio_ok_Back = Scambio_ok
        Application.DoEvents()
        Call Elabora_Matrice4x4_UP(Matrice4x4)
        Application.DoEvents()
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048(Matrice4x4)
            Application.DoEvents()
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            Application.DoEvents()
        End If
        Call cambia_colore_P(sender)

    End Sub

    Private Sub But_Down_Click(sender As Object, e As EventArgs) Handles But_Down.Click
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
        Scambio_ok_Back = Scambio_ok
        Application.DoEvents()
        Call Elabora_Matrice4x4_Down(Matrice4x4)
        Application.DoEvents()
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048(Matrice4x4)
            Application.DoEvents()
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            Application.DoEvents()
        End If
        Call cambia_colore_P(sender)

    End Sub

    Private Sub But_R_Click(sender As Object, e As EventArgs) Handles But_R.Click
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
        Scambio_ok_Back = Scambio_ok
        Application.DoEvents()
        Call Elabora_Matrice4x4_Right(Matrice4x4)
        Application.DoEvents()
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048(Matrice4x4)
            Application.DoEvents()
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            Application.DoEvents()
        End If
        Call cambia_colore_P(sender)

    End Sub

    Private Sub But_L_Click(sender As Object, e As EventArgs) Handles But_L.Click
        Call Copia_Matrice2048(Matrice4x4, Matrice_Back1)
        Scambio_ok_Back = Scambio_ok
        Application.DoEvents()
        Call Elabora_Matrice4x4_Left(Matrice4x4)
        Application.DoEvents()
        If Scambio_ok = True Then
            Call Random_Matrice4x4_2048(Matrice4x4)
            Application.DoEvents()
            Call Visualizza_Immagine_Celle2048(Matrice4x4)
            Application.DoEvents()
        End If
        Call cambia_colore_P(sender)

    End Sub

    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keyData As Keys) As Boolean

        ' intercetto le frecce
        Select Case keyData
            Case Keys.Down
                But_Down_Click(But_Down, New System.EventArgs())
            Case Keys.Up
                But_UP_Click(But_UP, New System.EventArgs())
            Case Keys.Left
                But_L_Click(But_L, New System.EventArgs())
            Case Keys.Right
                But_R_Click(But_R, New System.EventArgs())
        End Select
        Return True

    End Function

    Private Sub Back1PassoToolStrip_Click(sender As Object, e As EventArgs) Handles Back1PassoToolStrip.Click

        Call Copia_Matrice2048(Matrice_Back1, Matrice4x4)
        Application.DoEvents()
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        Scambio_ok = Scambio_ok_Back
        mosse -= 1
    End Sub

    Public Sub cambia_colore_P(ByVal sender As Object)

        Dim nome_P As String = sender.text

        Me.But_L.BackColor = Color.White
        Me.But_R.BackColor = Color.White
        Me.But_UP.BackColor = Color.White
        Me.But_Down.BackColor = Color.White

        Select Case nome_P
            Case = "L"
                Me.But_L.BackColor = Color.Aquamarine
            Case = "R"
                Me.But_R.BackColor = Color.Aquamarine
            Case = "UP"
                Me.But_UP.BackColor = Color.Aquamarine
            Case = "Down"
                Me.But_Down.BackColor = Color.Aquamarine
        End Select

        mosse += 1


    End Sub

    Public Sub Verifica_Ultima_Potenza(ByVal P As Int32)
        Application.DoEvents()
        Thread.Sleep(200)

        Ultima_Potenza = P

        If Ultima_Potenza > Max_Potenza_Raggiunta Then
            Max_Potenza_Raggiunta = Ultima_Potenza
        End If

        If Max_Potenza_Raggiunta = 2048 And Obiettivi_Punteggio(0) = 2048 Then
            Suono4.play()
            Obiettivi_Punteggio(0) = 0
        End If

        If Max_Potenza_Raggiunta = 4096 And Obiettivi_Punteggio(0) = 4096 Then
            Suono4.play()
            Obiettivi_Punteggio(0) = 0
        End If

        If Max_Potenza_Raggiunta = 8192 And Obiettivi_Punteggio(0) = 8192 Then
            Suono4.play()
            Obiettivi_Punteggio(0) = 0
        End If
        Application.DoEvents()
    End Sub

    Public Sub Elabora_Matrice4x4_Down(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0

        While Ripeti < NumericUpDown1.Value

            For c As Int32 = 4 To 2 Step -1
                For r As Int32 = 1 To 4

                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(c, r) = Matr2048(c - 1, r) And Matr2048(c, r) > 1 Then
                            Matr2048(c, r) *= 2
                            Matr2048(c - 1, r) = 1
                            Punteggio += Matr2048(c, r)
                            Scambio_ok = True
                            Suono5.play()
                            Application.DoEvents()
                            Call Verifica_Ultima_Potenza(Matr2048(c, r))
                        End If
                    End If

                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For c As Int32 = 4 To 2 Step -1
                For r As Int32 = 1 To 4
                    If Matr2048(c, r) = 1 And Matr2048(c - 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c - 1, r)
                        Matr2048(c - 1, r) = 1
                        Ripeti = 1
                    End If
                Next r
            Next c
        End While

    End Sub

    Public Sub Elabora_Matrice4x4_UP(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0

        While Ripeti < NumericUpDown1.Value

            For c As Int32 = 1 To 3
                For r As Int32 = 4 To 1 Step -1

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(c, r) = Matr2048(c + 1, r) And Matr2048(c, r) > 1 Then
                            Matr2048(c, r) *= 2
                            Matr2048(c + 1, r) = 1
                            Punteggio += Matr2048(c, r)
                            Scambio_ok = True
                            Suono5.play()
                            Application.DoEvents()
                            Call Verifica_Ultima_Potenza(Matr2048(c, r))
                        End If
                    End If

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Scambio_ok = True
                    End If
                Next r
            Next c
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For c As Int32 = 1 To 3
                For r As Int32 = 4 To 1 Step -1

                    If Matr2048(c, r) = 1 And Matr2048(c + 1, r) > 1 Then
                        Matr2048(c, r) = Matr2048(c + 1, r)
                        Matr2048(c + 1, r) = 1
                        Ripeti = 1
                    End If
                Next r
            Next c
        End While

    End Sub

    Public Sub Elabora_Matrice4x4_Left(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0

        While Ripeti < NumericUpDown1.Value

            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 3

                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(r, c) = Matr2048(r, c + 1) And Matr2048(r, c) > 1 Then
                            Matr2048(r, c) *= 2
                            Matr2048(r, c + 1) = 1
                            Punteggio += Matr2048(r, c)
                            Scambio_ok = True
                            Suono5.play()
                            Application.DoEvents()
                            Call Verifica_Ultima_Potenza(Matr2048(r, c))
                        End If
                    End If

                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Scambio_ok = True
                    End If
                Next c
            Next r
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 3
                    If Matr2048(r, c) = 1 And Matr2048(r, c + 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c + 1)
                        Matr2048(r, c + 1) = 1
                        Ripeti = 1
                    End If
                Next c
            Next r
        End While

    End Sub

    Public Sub Elabora_Matrice4x4_Right(ByRef Matr2048 As Int32(,))
        Dim Ripeti As Int32 = 0

        While Ripeti < NumericUpDown1.Value

            For r As Int32 = 1 To 4
                For c As Int32 = 4 To 2 Step -1
                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Scambio_ok = True
                    End If

                    If Ripeti = 0 Or Ripeti = 2 Then
                        If Matr2048(r, c) = Matr2048(r, c - 1) And Matr2048(r, c) > 1 Then
                            Matr2048(r, c) *= 2
                            Matr2048(r, c - 1) = 1
                            Punteggio += Matr2048(r, c)
                            Scambio_ok = True
                            Suono5.play()
                            Application.DoEvents()
                            Call Verifica_Ultima_Potenza(Matr2048(r, c))
                        End If
                    End If

                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Scambio_ok = True
                    End If

                Next c
            Next r
            Ripeti += 1
        End While

        Ripeti = 1
        While Ripeti = 1
            Ripeti = 0
            For r As Int32 = 1 To 4
                For c As Int32 = 4 To 2 Step -1
                    If Matr2048(r, c) = 1 And Matr2048(r, c - 1) > 1 Then
                        Matr2048(r, c) = Matr2048(r, c - 1)
                        Matr2048(r, c - 1) = 1
                        Ripeti = 1
                    End If
                Next c
            Next r
        End While

    End Sub

    Public Sub Inizializza_Matrice2048(ByRef Matr2048 As Int32(,))

        For r As Int32 = 1 To 4
            For c As Int32 = 1 To 4
                Matr2048(r, c) = 1
            Next c
        Next r

        Select Case My.Settings.Max_Valore
            Case = 2048
                Obiettivi_Punteggio(0) = 0
            Case = 4096
                Obiettivi_Punteggio(1) = 0
            Case 8192
                Obiettivi_Punteggio(2) = 0
        End Select

    End Sub

    Public Sub Copia_Matrice2048(ByRef Matr2048 As Int32(,), ByRef CopiaMatrice As Int32(,))
        'clona la matrice base
        For r As Int32 = 1 To 4
            For c As Int32 = 1 To 4
                CopiaMatrice(r, c) = Matr2048(r, c)
            Next c
        Next r

    End Sub

    Public Sub Random_Matrice4x4_2048(ByRef Matr2048 As Int32(,))

        Dim ran As New Random
        Dim Riga() As Int32 = {1, 2, 3, 4}
        Dim Colonna() As Int32 = {1, 2, 3, 4}
        Dim R As Int32
        Dim C As Int32
        Application.DoEvents()
        'verifica che ci siano mosse possimili
        Dim flag As Boolean = False
        For R = 1 To 4
            For C = 1 To 4
                If Matr2048(R, C) = 1 Then
                    flag = True
                End If
            Next C
        Next R

        If flag = False Then
            Thread.Sleep(100)
            Suono1.play()
            Application.DoEvents()
            MsgBox(" Non ci sono coppie possibili, Cambia pulsante o Ritenta ")
            Exit Sub
        End If

Avvia:
        Do
            R = Riga(ran.Next(0, 4))
            C = Colonna(ran.Next(0, 4))
            If Matr2048(R, C) = 1 Then
                Matr2048(R, C) = 2
                Exit Do
            End If
        Loop
        If Stato_Eventi = Stato.Azzerato Then
            Stato_eventi = Stato.Avviato
            Application.DoEvents()
            GoTo Avvia
        End If

    End Sub

    Public Sub Visualizza_Immagine_Celle2048(ByRef Matr2048 As Int32(,))

        For i As Int32 = 1 To 16
            Dim Tag_Cella As String = ""
            Tag_Cella = Mat4x4Pict_2040(i).Tag
            For r As Int32 = 1 To 4
                For c As Int32 = 1 To 4
                    Dim index_M As String = r & "-" & c

                    If index_M = Tag_Cella Then
                        Select Case Matr2048(r, c)
                            Case 1
                                Mat4x4Pict_2040(i).Image = Nothing
                            Case 2
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(0)
                            Case 4
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(1)
                            Case 8
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(2)
                            Case 16
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(3)
                            Case 32
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(4)
                            Case 64
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(5)
                            Case 128
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(6)
                            Case 256
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(7)
                            Case 512
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(8)
                            Case 1024
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(9)
                            Case 2048
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(10)
                            Case 4096
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(11)
                            Case 8192
                                Mat4x4Pict_2040(i).Image = Me.ImageList1.Images(12)
                        End Select
                    End If
                Next c

            Next r

        Next i

        Select Case Max_Potenza_Raggiunta
            Case 2
                Me.PictureBox1.Image = Me.ImageList1.Images(0)
            Case 4
                Me.PictureBox1.Image = Me.ImageList1.Images(1)
            Case 8
                Me.PictureBox1.Image = Me.ImageList1.Images(2)
            Case 16
                Me.PictureBox1.Image = Me.ImageList1.Images(3)
            Case 32
                Me.PictureBox1.Image = Me.ImageList1.Images(4)
            Case 64
                Me.PictureBox1.Image = Me.ImageList1.Images(5)
            Case 128
                Me.PictureBox1.Image = Me.ImageList1.Images(6)
            Case 256
                Me.PictureBox1.Image = Me.ImageList1.Images(7)
            Case 512
                Me.PictureBox1.Image = Me.ImageList1.Images(8)
            Case 1024
                Me.PictureBox1.Image = Me.ImageList1.Images(9)
            Case 2048
                Me.PictureBox1.Image = Me.ImageList1.Images(10)
            Case 4096
                Me.PictureBox1.Image = Me.ImageList1.Images(11)
            Case 8192
                Me.PictureBox1.Image = Me.ImageList1.Images(12)
        End Select

        Dim new_record As Int32
        new_record = Punteggio - (CInt(My.Settings.Record))
        If new_record > 0 Then
            Giocatore = TextBox_Nome.Text
            My.Settings.Record = Punteggio
            My.Settings.Mosse_Rec = mosse
            My.Settings.Nome = Giocatore
            My.Settings.Max_Valore = Max_Potenza_Raggiunta
            My.Settings.Save()
            Application.DoEvents()
            Thread.Sleep(200)
            If Nuovo_Record = False Then
                Nuovo_Record = True
                Suono2.play()
                Label1.ForeColor = Color.Red
                Application.DoEvents()
            End If
        End If
            Label1.Text = "Punteggio Record: " & My.Settings.Record
        Label2.Text = "Mosse: " & My.Settings.Mosse_Rec
        Label3.Text = "Record di: " & My.Settings.Nome
        Label4.Text = "Max_Val: " & My.Settings.Max_Valore
        Me.TSLabel_Stato.Text = "Stato: Punteggio " & Punteggio & "   Mosse " & mosse
        Me.Refresh()
        Scambio_ok = False
        Application.DoEvents()
    End Sub

    Private Sub AzzeraToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AzzeraToolStripMenuItem.Click

        Stato_eventi = Stato.Azzerato
        Punteggio = 0
        mosse = 0
        Max_Potenza_Raggiunta = 2
        Call Inizializza_Matrice2048(Matrice4x4)
        Call Random_Matrice4x4_2048(Matrice4x4)
        Call Visualizza_Immagine_Celle2048(Matrice4x4)
        Scambio_ok = True

    End Sub

    Private Sub EsciToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EsciToolStripMenuItem.Click
        My.Settings.Save()
        End
    End Sub

End Class
